#ifndef _VECTOR_H_
#define _VECTOR_H_

#ifndef RAD
#define RAD 57.295779513082320900
#endif

//57,295779513082320900

class angle
{
public:
	double val;
	angle(){val = 0;}
	angle(double v){val = v;}
	angle operator+(double v);
	angle operator-(double v);
	angle & operator+=(double v);
	angle & operator-=(double v);
	angle & operator=(double v);
	angle operator-();
	bool operator<(angle a);
	bool operator>(angle a);
	double operator>>(angle a);
};
angle operator+(double v,angle a);
angle operator-(double v,angle a);
angle calcang(double x2, double y2, double x1, double y1);

class vector_pol;

class vector
{
public:
	double v[4];
	vector();
	vector(double x, double y);
	vector(double x, double y, double s);
	vector(double x, double y, double s, double w);
	vector_pol pol();
	double mag();
	angle ang();
	double x();
	double y();
	vector & x(double x);
	vector & y(double y);
	vector operator+(const vector & vect);
	vector operator-(const vector & vect);
	vector operator-();
	vector operator*(double val);
	vector operator/(double val);
};

vector operator*(double val, const vector & vect);

class vector_pol
{
public:
	double mag;
	angle ang;
	vector_pol() {}
	vector_pol(double m, double a);
	vector rec();
	double x();
	double y();
	vector_pol operator*(double val);
	vector_pol operator/(double val);
	vector_pol operator-();
	vector_pol project(angle a);
};
vector_pol operator*(double val, const vector_pol & vect);
vector_pol operator/(double val, const vector_pol & vect);
angle calcang(double x2, double y2, double x1, double y1);

#endif
